/* WebMail/2 v1.0 beta 16 by Dimitris 'sehh' Michelinakis <sehh@altered.com> */

/* IP and Port of the WebManager */
Globals.!serv = 10.10.10.9
Globals.!port = 1924

/* Path to the dynamic parsed .wm files */
/* if you leave it as null ("") then its %etc%\webmailhtml by default */
/* Globals.!WMPath = "" */
Globals.!WMPath = "c:\mptn\etc\webmailnew"

/* The following variables are for external authentication only */
Globals.!ExA = "NO" /* Change to "YES" if you want to use external authentication */
Globals.!ExP = "c:\tcpip\os2httpd\auth.cmd" /* Full path and filename to your external program */
Globals.!pop3 = "10.10.10.1" /* POP3 server IP address */
Globals.!pop3p = "110" /* Port of POP3 server */
Globals.!smtp = "10.10.10.1" /* SMTP server IP address */
Globals.!smtpp = "25" /* Port of SMTP server */

/* WebMail CGI */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs
call RxFuncAdd 'SockLoadFuncs','RxSock','SockLoadFuncs'
call SockLoadFuncs(1)
Globals.!myinfo = "WebMail/2 for OS/2"
Globals.!requestmethod = value("REQUEST_METHOD",,'os2environment')
if Globals.!requestmethod="POST" then Globals.!querystring=URLDecode(linein())
else Globals.!querystring = URLDecode(value("QUERY_STRING",,'os2environment'))
if pos("flogin=",Globals.!querystring)>0 then parse value Globals.!querystring with Globals.!stat1 "&" Globals.!user "&" Globals.!pazz
else parse value Globals.!querystring with Globals.!stat1 "&" Globals.!stat2 "&" Globals.!stat3
Globals.!SetCookie = ""
Globals.!EmailReply = ""
Globals.!mail.0 = 0
Globals.!totalmail = 0
Globals.!myself = value("SCRIPT_NAME",,'os2environment')
if Globals.!WMPath = "" then Globals.!WMPath = value("ETC",,'os2environment')||"\webmailhtml"
if pos(Globals.!myself,value("HTTP_REFERER",,'os2environment'))<1 then call UserLoginScreen
else if pos("flogin=",Globals.!stat1)>0 then call CheckLogon "fcheckemail"
else if pos("refresh",Globals.!stat1)>0 then call CheckLogon "checkemail"
else if pos("read",Globals.!stat1)>0 then call CheckLogon "read"
else if pos("newpost",Globals.!stat1)>0 then call CheckLogon "newpost"
else if pos("new",Globals.!stat1)>0 then call CheckLogon "new"
else if pos("delete",Globals.!stat1)>0 then call CheckLogon "delete"
else if pos("logoff",Globals.!stat1)>0 then call CheckLogon "logoff"
/* else if pos("download",Globals.!stat1)>0 then call CheckLogon "download" */
call UserLoginScreen
return

CheckLogon: procedure expose Globals.
if Globals.!ExA = "NO" then do
 Globals.!pop3 = ""
 Globals.!pop3p = ""
 Globals.!smtp = ""
 Globals.!smtpp = ""
 socket = SockSocket("AF_INET","SOCK_STREAM",0)
 if socket = -1 then call CGIErrorScreen "CheckLogon: Error open socket"
 server.!family = "AF_INET"
 server.!port   = Globals.!port
 server.!addr   = Globals.!serv
 rc = SockConnect(socket,"server.!")
 if rc = -1 then call CGIErrorScreen "CheckLogon: Error on Socket/Port Connection "||server.!addr||"-"||server.!port
 Globals.!clientIP = value("REMOTE_ADDR",,'os2environment')
 if Globals.!clientIP = "" then call ServerErrorScreen "CheckLogon: Can't detect your client"
 if ARG(1) = "fcheckemail" then tmp1=0
 else if ARG(1) = "logoff" then tmp1=2
 else tmp1=1
 if tmp1=0 then do
  Globals.!user = substr(Globals.!user,3,length(Globals.!user)-2)
  Globals.!pazz = substr(Globals.!pazz,3,length(Globals.!pazz)-2)
  call SendData tmp1||":"||Globals.!user||":"||Globals.!pazz||":"||Globals.!clientIP||":"
 end; else do
  if ARG(1)="newpost" then do
   tmp = substr(Globals.!stat2,3)
   Globals.!stat2 = Globals.!stat3
   Globals.!stat3 = tmp
  end
  if Globals.!stat3<>"" then
   call SendData tmp1||":"||Globals.!stat3||":"||Globals.!clientIP||":"
  else
   call SendData tmp1||":"||Globals.!stat2||":"||Globals.!clientIP||":"
 end
 if tmp1<>2 then do
  call ReceiveData
  if pos("[WebManager2] OK",newData)<1 then do
   call SysSleep 6
   call ServerErrorScreen "Login refused"
  end
  parse value newData with . ":" Globals.!pop3 ":" Globals.!pop3p ":" Globals.!smtp ":" Globals.!smtpp ":" Globals.!AuthID ":" Globals.!user ":" Globals.!pazz ":"
  rc = SockSoClose(socket)
  if rc = -1 then call CGIErrorScreen "CheckLogon: Error on SockSoClose"
  if ARG(1) = "checkemail" | ARG(1) = "fcheckemail" then do
   /* Globals.!SetCookie = "SET" */
   call CheckEmail
  end; else if ARG(1) = "read" then call ReceiveEmail
  else if ARG(1) = "new" then call NewEmailScreen
  else if ARG(1) = "newpost" then call NewEmail
  else if ARG(1) = "delete" then call DeleteEmail
  else if ARG(1) = "download" then call Download
 end; else do
  call UserLoginScreen
 end
end; else do
 Globals.!clientIP = value("REMOTE_ADDR",,'os2environment')
 if Globals.!clientIP = "" then call ServerErrorScreen "CheckLogon: Can't detect your client"
 if ARG(1) = "fcheckemail" then tmp1=0
 else if ARG(1) = "logoff" then tmp1=2
 else tmp1=1
 if tmp1=0 then do
  Globals.!user = substr(Globals.!user,3,length(Globals.!user)-2)
  Globals.!pazz = substr(Globals.!pazz,3,length(Globals.!pazz)-2)
  parms = tmp1||":"||Globals.!user||":"||Globals.!pazz||":"||Globals.!clientIP||":"
 end; else parms = tmp1||":"||Globals.!stat2||":"
 "@cmd /c "||'@'||Globals.!ExP||' >nul 2>nul'
 if tmp1<>2 then do
  if RC <> "2" then do
   call SysSleep 6
   call ServerErrorScreen "Login refused"
  end
  if ARG(1) = "checkemail" | ARG(1) = "fcheckemail" then call CheckEmail
  else if ARG(1) = "read" then call ReceiveEmail
  else if ARG(1) = "new" then call NewEmailScreen
  else if ARG(1) = "newpost" then call NewEmail
  else if ARG(1) = "delete" then call DeleteEmail
  else if ARG(1) = "download" then call Download
 end; else do
  call UserLoginScreen
 end
end
call SysSleep 6
call ServerErrorScreen "Login refused"
return

CheckEmail: procedure expose Globals.
socket = SockSocket("AF_INET","SOCK_STREAM",0)
if socket = -1 then call CGIErrorScreen "CheckEmail: Error open socket"
server.!family = "AF_INET"
server.!port   = Globals.!pop3p
server.!addr   = Globals.!pop3
rc = SockConnect(socket,"server.!")
if rc = -1 then call CGIErrorScreen "CheckEmail: Error on Socket/Port Connection "||server.!addr||"-"||server.!port
call ReceiveData
if substr(newData,1,3)<>"+OK" then call ServerErrorScreen "CheckEmail: Server refused connection"
parse value Globals.!user with tmpuser "@" tmpdomain
call SendData "USER "||tmpuser||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "CheckEmail: Server refused user login"
end
call SendData "PASS "||Globals.!pazz||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "CheckEmail: Failed login due to password error"
end
call SendData "STAT"||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "CheckEmail: Email server couldn't get status"
end
parse value newData with . Globals.!totalmail .
if datatype(Globals.!totalmail,"N")<>1 then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "CheckEmail: Server returned wrong value"
end
zz=0
do i=1 to Globals.!totalmail
 call SendData "TOP "||i||" 0"||'0d0a'x
 call ReceiveData(5)
 if substr(newData,1,3)="+OK" then do
  oldData=""
  do while pos('0d0a'x||"."||'0d0a'x,newData)<1
   call ReceiveData(256)
   oldData=oldData||newData
  end
  zz=zz+1
  Globals.!mail.zz = oldData
 end
end
Globals.!mail.0 = zz
ListMail.0 = 0
do i=1 to Globals.!mail.0
 if pos("From:",Globals.!mail.i)<1 then iterate
 tmp1 = pos("From:",Globals.!mail.i)+6
 tmp2 = pos('0d0a'x,Globals.!mail.i,tmp1)
 tmp3 = space(substr(Globals.!mail.i,tmp1,tmp2-tmp1))
 if pos("<",tmp3)>0 then tmp3 = translate(tmp3,"(","<")
 else tmp3 = "("||tmp3
 if pos(">",tmp3)>0 then tmp3 = translate(tmp3,")",">")
 else tmp3 = tmp3||")"
 ListMail.i.!From = tmp3
 tmp1 = pos("Subject:",Globals.!mail.i)+9
 tmp2 = pos('0d0a'x,Globals.!mail.i,tmp1)
 ListMail.i.!Subject = space(substr(Globals.!mail.i,tmp1,tmp2-tmp1))
 tmp1 = pos("Date:",Globals.!mail.i)+6
 ListMail.i.!Date = space(substr(Globals.!mail.i,tmp1,16))
 if pos("Content-Type:",Globals.!mail.i)>0 then do
  tmp1 = pos("Content-Type:",Globals.!mail.i)+14
  tmp2 = pos('0d0a'x,Globals.!mail.i,tmp1)
  tmp3 = space(substr(Globals.!mail.i,tmp1,tmp2-tmp1))
  if pos("multipart/mixed;",tmp3)>0 then ListMail.i.!ContentType = "YES"
 end
 if pos("Priority:",Globals.!mail.i)>0 then do
  tmp1 = pos("Priority:",Globals.!mail.i)+10
  tmp2 = pos('0d0a'x,Globals.!mail.i,tmp1)
  tmp3 = space(substr(Globals.!mail.i,tmp1,tmp2-tmp1))
  if tmp3 = "High" then 
   ListMail.i.!Priority = "High"
  else if tmp3 = "Low" then
   ListMail.i.!Priority = "Low"
  else
   ListMail.i.!Priority = "Normal"
 end; else ListMail.i.!Priority = "Normal"
end
call SendData "QUIT"||'0d0a'x
rc = SockSoClose(socket)
if rc = -1 then call CGIErrorScreen "CheckEmail: Error on SockSoClose"
call ParseHTML Globals.!WMPath || "\header.wm", 1
if Globals.!totalmail > 0 then do
 Globals.!ListTable = ""
 do i=1 to Globals.!totalmail
  if ListMail.i.!ContentType = "YES" then
   Globals.!ContentType = ParseHTML( Globals.!WMPath || "\attachment-yes.wm",0,1 ) || '0d0a'x
  else
   Globals.!ContentType = ParseHTML( Globals.!WMPath || "\attachment-no.wm",0,1 ) || '0d0a'x
  if ListMail.i.!Priority = "High" then
   Globals.!Priority = ParseHTML( Globals.!WMPath || "\priority-high.wm",0,1 ) || '0d0a'x
  else if ListMail.i.!Priority = "Low" then
   Globals.!Priority = ParseHTML( Globals.!WMPath || "\priority-low.wm",0,1 ) || '0d0a'x
  else
   Globals.!Priority = ParseHTML( Globals.!WMPath || "\priority-normal.wm",0,1 ) || '0d0a'x
  Globals.!EmailReply = substr(ListMail.i.!From,pos("(",ListMail.i.!From)+1,lastpos(")",ListMail.i.!From)-pos("(",ListMail.i.!From)-1)
  Globals.!ListTable = Globals.!ListTable || ParseHTML( Globals.!WMPath || "\listemails-table.wm",0,1 ) || '0d0a'x
 end
end; else Globals.!ListTable = "No mail"
call ParseHTML Globals.!WMPath || "\listemails.wm"
call ParseHTML Globals.!WMPath || "\footer.wm"
exit

ReceiveEmail: procedure expose Globals.
socket = SockSocket("AF_INET","SOCK_STREAM",0)
if socket = -1 then call CGIErrorScreen "ReceiveEmail: Error open socket"
server.!family = "AF_INET"
server.!port   = Globals.!pop3p
server.!addr   = Globals.!pop3
rc = SockConnect(socket,"server.!")
if rc = -1 then call CGIErrorScreen "ReceiveEmail: Error on Socket/Port Connection "||server.!addr||"-"||server.!port
call ReceiveData
if substr(newData,1,3)<>"+OK" then call ServerErrorScreen "ReceiveEmail: Server refused connection"
parse value Globals.!user with tmpuser "@" tmpdomain
call SendData "USER "||tmpuser||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "ReceiveEmail: Server refused user login"
end
call SendData "PASS "||Globals.!pazz||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "ReceiveEmail: Failed login due to password error"
end
call SendData "LIST "||Globals.!stat2||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "ReceiveEmail: Server couldn't list email"
end
parse value newData with . . tmpsize '0d0a'x
call SendData "RETR "||Globals.!stat2||'0d0a'x
tmp=""
do while length(tmp) < tmpsize
 call ReceiveData
 tmp = tmp||newData
end
if substr(tmp,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "ReceiveEmail: Server couldn't retrieve email"
end
call SendData "QUIT"||'0d0a'x
rc = SockSoClose(socket)
if rc = -1 then call CGIErrorScreen "ReceiveEmail: Error on SockSoClose"
i=Globals.!stat2
tmp1 = pos("From:",tmp)+6
tmp2 = pos('0d0a'x,tmp,tmp1)
tmp3 = space(substr(tmp,tmp1,tmp2-tmp1))
if pos("<",tmp3)>0 then tmp3 = translate(tmp3,"(","<")
else tmp3 = "("||tmp3
if pos(">",tmp3)>0 then tmp3 = translate(tmp3,")",">")
else tmp3 = tmp3||")"
ListMail.i.!From = tmp3
tmp1 = pos("Subject:",tmp)+9
tmp2 = pos('0d0a'x,tmp,tmp1)
tmp2 = translate(tmp2,"(","<")
tmp2 = translate(tmp2,")",">")
ListMail.i.!Subject = space(substr(tmp,tmp1,tmp2-tmp1))
tmp1 = pos("Date:",tmp)+6
tmp2 = pos('0d0a'x,tmp,tmp1)
ListMail.i.!Date = space(substr(tmp,tmp1,16))
ListMail.!Show = substr(tmp,1,lastpos('0d0a'x||"."||'0d0a'x,tmp)-1)
ListMail.!Show = substr(ListMail.!Show, pos('0d0a'x,ListMail.!Show)+2)
if pos("Content-Type:",tmp)>0 then do
 tmp1 = pos("Content-Type:",tmp)+14
 tmp2 = pos('0d0a'x,tmp,tmp1)
 tmp3 = space(substr(tmp,tmp1,tmp2-tmp1))
 if pos("multipart/mixed;",tmp3)>0 then do
  ListMail.i.!ContentType = "YES"
  boundary = substr(tmp3, pos("boundary=",tmp3)+10)
  boundary = '0d0a'x||"--"||substr(boundary, 1, length(boundary)-1)||'0d0a'x
  tmp1 = pos(boundary,ListMail.!Show)+length(boundary)
  tmp1 = pos('0d0a'x||'0d0a'x,ListMail.!Show,tmp1)+4
  tmp2 = pos(boundary,ListMail.!Show,tmp1)
  ListMail.!Show = substr(ListMail.!Show, tmp1, tmp2-tmp1)
 end; else do
  tmp1 = pos('0d0a'x||'0d0a'x,ListMail.!Show)+4
  ListMail.!Show = substr(ListMail.!Show, tmp1)
 end
end
if pos("Priority:",tmp)>0 then do
 tmp1 = pos("Priority:",tmp)+10
 tmp2 = pos('0d0a'x,tmp,tmp1)
 tmp3 = space(substr(tmp,tmp1,tmp2-tmp1))
 if tmp3 = "High" then
  Globals.!Priority = ParseHTML( Globals.!WMPath || "\priority-high.wm",0,1 ) || '0d0a'x
 else if tmp3 = "Low" then
  Globals.!Priority = ParseHTML( Globals.!WMPath || "\priority-low.wm",0,1 ) || '0d0a'x
 else
  Globals.!Priority = ParseHTML( Globals.!WMPath || "\priority-normal.wm",0,1 ) || '0d0a'x
end; else Globals.!Priority = ParseHTML( Globals.!WMPath || "\priority-normal.wm",0,1 ) || '0d0a'x
call ParseHTML Globals.!WMPath || "\header.wm", 1
if ListMail.i.!ContentType = "YES" then
 Globals.!ContentType = ParseHTML( Globals.!WMPath || "\attachment-yes.wm",0,1 ) || '0d0a'x
else
 Globals.!ContentType = ParseHTML( Globals.!WMPath || "\attachment-no.wm",0,1 ) || '0d0a'x
Globals.!EmailReply = substr(ListMail.i.!From,pos("(",ListMail.i.!From)+1,lastpos(")",ListMail.i.!From)-pos("(",ListMail.i.!From)-1)
call ParseHTML Globals.!WMPath || "\reademail.wm"
call ParseHTML Globals.!WMPath || "\footer.wm"
exit

NewEmail: procedure expose Globals.
parse value Globals.!querystring with . "&" . "&t=" sendto "&c=" ccto "&b=" bccto "&s=" subject "&p=" epriority "&body=" body
socket = SockSocket("AF_INET","SOCK_STREAM",0)
if socket = -1 then call CGIErrorScreen "NewEmail: Error open socket"
server.!family = "AF_INET"
server.!port   = Globals.!smtpp
server.!addr   = Globals.!smtp
rc = SockConnect(socket,"server.!")
if rc = -1 then call CGIErrorScreen "NewEmail: Error on Socket/Port Connection"
call ReceiveData
if substr(newData,1,3)<>"220" then call ServerErrorScreen "NewEmail: Server refused connection"
call SendData "HELO "||server.!addr||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"250" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "NewEmail: Server dropped connection"
end
call SendData "MAIL FROM: <"||Globals.!user||">"||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"250" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "NewEmail: Server rejected email transfer"
end
if pos(" ",sendto)>0 then do
 tmp = sendto
 do while tmp<>""
  parse value tmp with sendto1 tmp
  call SendData "RCPT TO: <"||sendto1||">"||'0d0a'x
  call ReceiveData
  if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
   call SendData "QUIT"||'0d0a'x
   call ServerErrorScreen "NewEmail: Server rejected target email"
  end
 end
end; else do
 call SendData "RCPT TO: <"||sendto||">"||'0d0a'x
 call ReceiveData
 if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
  call SendData "QUIT"||'0d0a'x
  call ServerErrorScreen "NewEmail: Server rejected target email"
 end
end
if pos(" ",ccto)>0 then do
 tmp = ccto
 do while tmp<>""
  parse value tmp with sendto1 tmp
  call SendData "RCPT TO: <"||sendto1||">"||'0d0a'x
  call ReceiveData
  if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
   call SendData "QUIT"||'0d0a'x
   call ServerErrorScreen "NewEmail: Server rejected target email"
  end
 end
end; else if ccto<>"" then do
 call SendData "RCPT TO: <"||ccto||">"||'0d0a'x
 call ReceiveData
 if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
  call SendData "QUIT"||'0d0a'x
  call ServerErrorScreen "NewEmail: Server rejected target email"
 end
end
if pos(" ",bccto)>0 then do
 tmp = bccto
 do while tmp<>""
  parse value tmp with sendto1 tmp
  call SendData "RCPT TO: <"||sendto1||">"||'0d0a'x
  call ReceiveData
  if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
   call SendData "QUIT"||'0d0a'x
   call ServerErrorScreen "NewEmail: Server rejected target email"
  end
 end
end; else if bccto<>"" then do
 call SendData "RCPT TO: <"||bccto||">"||'0d0a'x
 call ReceiveData
 if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
  call SendData "QUIT"||'0d0a'x
  call ServerErrorScreen "NewEmail: Server rejected target email"
 end
end
call SendData "DATA"||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"354" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "NewEmail: Server rejected email data"
end
header = "From: <"||Globals.!user||">"||'0d0a'x
if pos(" ",sendto)>0 then do
 tmp = sendto
 parse value tmp with sendto1 tmp
 header = header||"To: <"||sendto1||">,"||'0d0a'x
 do while tmp<>""
  parse value tmp with sendto1 tmp
  header = header||"    <"||sendto1||">"
  if tmp<>"" then header=header||","||'0d0a'x
  else header=header||'0d0a'x
 end
end; else header = header||"To: <"||sendto||">"||'0d0a'x
if pos(" ",ccto)>0 then do
 tmp = sendto
 parse value tmp with sendto1 tmp
 header = header||"Cc: <"||sendto1||">,"||'0d0a'x
 do while tmp<>""
  parse value tmp with sendto1 tmp
  header = header||"    <"||sendto1||">"
  if tmp<>"" then header=header||","||'0d0a'x
  else header=header||'0d0a'x
 end
end; else if ccto<>"" then header = header||"Cc: <"||ccto||">"||'0d0a'x
tz = value("TZ",,'os2environment')
if pos(",",tz)>0 then tz=substr(tz,1,pos(",",tz)-1)
header = header||"Date: "||substr(date("W"),1,3)||", "||date('N')||" "||time()||" "||tz||'0d0a'x
header = header||"Priority: "||epriority||'0d0a'x
header = header||"X-Mailer: "||Globals.!myinfo||'0d0a'x
header = header||"Content-Type: text/plain"||'0d0a'x
header = header||"Subject: "||subject||'0d0a'x||'0d0a'x
body=header||body
call SendData body
call SendData '0d0a'x||"."||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"250" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "NewEmail: Server rejected email transfer"
end
call SendData "QUIT"||'0d0a'x
rc = SockSoClose(socket)
if rc = -1 then call CGIErrorScreen "NewEmail: Error on SockSoClose"
call CheckEmail
return

DeleteEmail: procedure expose Globals.
socket = SockSocket("AF_INET","SOCK_STREAM",0)
if socket = -1 then call CGIErrorScreen "DeleteEmail: Error open socket"
server.!family = "AF_INET"
server.!port   = Globals.!pop3p
server.!addr   = Globals.!pop3
rc = SockConnect(socket,"server.!")
if rc = -1 then call CGIErrorScreen "DeleteEmail: Error on Socket/Port Connection"
call ReceiveData
if substr(newData,1,3)<>"+OK" then call ServerErrorScreen "DeleteEmail: Server refused connection"
parse value Globals.!user with tmpuser "@" tmpdomain
call SendData "USER "||tmpuser||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "DeleteEmail: Server refused user login"
end
call SendData "PASS "||Globals.!pazz||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "DeleteEmail: Failed login due to password error"
end
if pos("all",Globals.!stat2)>0 then do
 call SendData "STAT"||'0d0a'x
 call ReceiveData
 if substr(newData,1,3)<>"+OK" then do
  call SendData "QUIT"||'0d0a'x
  call ServerErrorScreen "DeleteEmail: Email server couldn't get status"
 end
 parse value newData with . Globals.!totalmail .
 if datatype(Globals.!totalmail,"N")<>1 then do
  call SendData "QUIT"||'0d0a'x
  call ServerErrorScreen "DeleteEmail: Server returned wrong value"
 end
 do i=1 to Globals.!totalmail
  call SendData "DELE "||i||'0d0a'x
  call ReceiveData
  if substr(newData,1,3)<>"+OK" then do
   call SendData "QUIT"||'0d0a'x
   call ServerErrorScreen "DeleteEmail: Server couldn't delete email<br> or email already deleted"
  end
 end
end; else do
 call SendData "DELE "||Globals.!stat2||'0d0a'x
 call ReceiveData
 if substr(newData,1,3)<>"+OK" then do
  call SendData "QUIT"||'0d0a'x
  call ServerErrorScreen "DeleteEmail: Server couldn't delete email<br> or email already deleted"
 end
end
call SendData "QUIT"||'0d0a'x
rc = SockSoClose(socket)
if rc = -1 then call CGIErrorScreen "DeleteEmail: Error on SockSoClose"
call SysSleep 2
call CheckEmail
return

Download: procedure expose Globals.
socket = SockSocket("AF_INET","SOCK_STREAM",0)
if socket = -1 then call CGIErrorScreen "ReceiveEmail: Error open socket"
server.!family = "AF_INET"
server.!port   = Globals.!pop3p
server.!addr   = Globals.!pop3
rc = SockConnect(socket,"server.!")
if rc = -1 then call CGIErrorScreen "ReceiveEmail: Error on Socket/Port Connection "||server.!addr||"-"||server.!port
call ReceiveData
if substr(newData,1,3)<>"+OK" then call ServerErrorScreen "ReceiveEmail: Server refused connection"
parse value Globals.!user with tmpuser "@" tmpdomain
call SendData "USER "||tmpuser||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "ReceiveEmail: Server refused user login"
end
call SendData "PASS "||Globals.!pazz||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "ReceiveEmail: Failed login due to password error"
end
call SendData "LIST "||Globals.!stat2||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "ReceiveEmail: Server couldn't list email"
end
parse value newData with . . tmpsize '0d0a'x
call SendData "RETR "||Globals.!stat2||'0d0a'x
tmp=""
do while length(tmp) < tmpsize
 call ReceiveData
 tmp = tmp||newData
end
if substr(tmp,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ServerErrorScreen "ReceiveEmail: Server couldn't retrieve email"
end
call SendData "QUIT"||'0d0a'x
rc = SockSoClose(socket)
if rc = -1 then call CGIErrorScreen "ReceiveEmail: Error on SockSoClose"
say "Content-type: www/unknown"
say ""
say OLE
exit

SendData: procedure expose socket
rc = SockSend(socket,ARG(1))
if rc = -1 then call CGIErrorScreen "SendData: Error on SockSend"
return

ReceiveData: procedure expose socket newData
length = ARG(1)
if length = "" then length = 1024
rc = SockRecv(socket,"newData",length)
if rc = -1 then call CGIErrorScreen "ReceiveData: Error on SockRecv "||length
return

ParseHTML: procedure expose Globals. i ListMail.
findstring.1 = "*!WMVERSION!*:"||Globals.!myinfo
findstring.2 = "*!WMUSER!*:"||Globals.!user
findstring.3 = "*!WMPASS!*:"||Globals.!pazz
findstring.4 = "*!WMFILENAME!*:"||Globals.!myself
findstring.5 = "*!WMEMAILNUM!*:"||i
findstring.6 = "*!WMEMAILFROM!*:"||ListMail.i.!From
findstring.7 = "*!WMEMAILSUBJECT!*:"||ListMail.i.!Subject
findstring.8 = "*!WMEMAILDATE!*:"||ListMail.i.!Date
findstring.9 = "*!WMEMAILBODY!*:"||ListMail.!Show
findstring.10 = "*!WMEMAILTABLE!*:"||Globals.!ListTable
findstring.11 = "*!SERVERERROR!*:"||Globals.!ServerErr
findstring.12 = "*!WMATTACHMENT!*:"||Globals.!ContentType
findstring.13 = "*!WMEMAILPRIORITY!*:"||Globals.!Priority
findstring.14 = "*!WMAUTHID!*:"||Globals.!AuthID
findstring.15 = "*!WMEMAILREPLY!*:"||Globals.!EmailReply
findstring.0 = 15
if ARG(2)=1 then do
 say "Content-type: text/html"
 say "Cache-Control: max-age=30"
 if Globals.!SetCookie<>"" then do
  say "Set-Cookie: WEBMAIL="||Globals.!AuthID
 end
 say ""
end
newstr = ""
istr = stream(ARG(1), 'c', 'open read')
do while lines(ARG(1))>0
 tmp = linein(ARG(1))
 do ii=1 to findstring.0
  parse value findstring.ii with tmp1 ":" tmp2
  rc = pos(tmp1,tmp)
  if rc >0 then tmp = ReplaceStr(tmp,tmp1,tmp2)
 end
 if ARG(3)<>1 then say tmp
 else newstr = newstr || tmp|| '0d0a'x
end
return newstr

ReplaceStr: procedure
tmp1 = ARG(1)
tmp2 = ARG(2)
tmp3 = ARG(3)
do forever
 iz = pos(tmp2,tmp1)
 if iz<1 then leave
 tmp = substr(tmp1,1,iz-1)
 tmpp = substr(tmp1,iz+length(tmp2),length(tmp1)-iz+length(tmp2))
 tmp1 = tmp||tmp3||tmpp
end
return tmp1

UserLoginScreen: procedure expose Globals.
call ParseHTML Globals.!WMPath || "\userlogin.wm", 1
exit

NewEmailScreen: procedure expose Globals.
if Globals.!stat3<>"" then do
 Globals.!EmailReply = Globals.!stat2
end; else Globals.!EmailReply = ""
call ParseHTML Globals.!WMPath || "\header.wm", 1
call ParseHTML Globals.!WMPath || "\composeemail.wm"
call ParseHTML Globals.!WMPath || "\footer.wm"
exit

ServerErrorScreen: procedure expose Globals.
Globals.!ServerErr = ARG(1)
call ParseHTML Globals.!WMPath || "\servererror.wm", 1
exit

CGIErrorScreen: procedure expose Globals.
socket = SockSocket("AF_INET","SOCK_STREAM",0)
server.!family = "AF_INET"
server.!port   = Globals.!port
server.!addr   = Globals.!serv
call SockConnect socket,"server.!"
call SockSend socket,"3:"||ARG(1)
call SockSoClose socket
call ServerErrorScreen "An internal server error occured!"
exit

URLDecode: procedure
line = ARG(1)
line= translate(ARG(1)," ","+")
lineLen= LENGTH(line)
newLine= ''
i=1
do while i <= lineLen
 c= substr(line, i, 1)
 if c \= '%' then newLine = newLine || c
 else if i+2 <= lineLen then do
  newLine= newLine || x2c(substr(line, i+1, 2))
  i=i+2
 end
 i= i+1
end
return newLine
